﻿package {
	public class MyVector {
		public var x:Number;
		public var y:Number;
		
		public function MyVector(x:Number, y:Number):void {
			this.x = x;
			this.y = y;
		}
		
		public function normal():MyVector {
			return new MyVector(-y,x);
		}
		
		public function mult(f:Number):MyVector {
			return new MyVector(f*x,f*y);
		}
		
		public function div(f:Number):MyVector {
			return new MyVector(x/f,y/f);
		}
		
		public function len():Number {
			return Math.sqrt(x*x+y*y);
		}
		
		public function normalize():MyVector {
			return div(len());
		}
		
		public function dotProduct(v:MyVector):Number {
			return x*v.x+y*v.y;
		}
		
		public function add(v:MyVector):MyVector {
			return new MyVector(x+v.x,y+v.y);
		}
		
		public function projection(v:MyVector):MyVector {
			v = v.normalize();
			var dp:Number = dotProduct(v);
			return new MyVector(dp*v.x,dp*v.y);
		}
		
	}
}